clear all

addpath(genpath('.\utils'))

% call the data
load instance_ebBB84.mat


n = size(Gamma{1},1);
% construct MGamma, the matrix representation of Gamma( )
MGamma = zeros(length(gamma),n*(n+1)/2); 
for ii = 1:length(gamma)
    MGamma(ii,:) = HSvec(Gamma{ii},'realCase');
end


opt = [];
opt.verbose = 2;  

%%% Facial reduction for the set 
%%% {rho : Gamma(rho)=gamma, rho psd}, the usual spectrahedron
%%%% MGamma is a matrix representation of the linear map Gamma

% Call the FR routine  (facial reduction Gauss Newton Predictor Corrector)
[V,Out] = FRGNPC(Gamma,MGamma,gamma,opt);
% V: Facial range vector 

